#import <stdio.h>
#define KERNEL_FEATURES
#import <sys/param.h>
#import <sys/dir.h>
#import <sys/user.h>
#import "threads.h"
#import <mach/cthreads.h>
#define	MTHREAD
#import "cthread_internals.h"
#import "xm.h"

void ProcA(), ProcB();
condition_t task_done, task_ready;
mutex_t task_done_lock, task_ready_lock;
int proc;
enum {procAReady=1, procADone, procBReady, procBDone};
struct REGS_STRUCT threadState;
unsigned int threadStateCount = REGS_COUNT;

void main()
{
cthread_t aThread;
thread_t thread;
int proc_depth = 0;

	fprintf(stderr, "ProcA() = 0x%x; ProcB() = 0x%x; &proc_depth = 0x%x\n",
		ProcA, ProcB, &proc_depth);
	task_done = condition_alloc();
	task_ready = condition_alloc();
	task_done_lock = mutex_alloc();
	task_ready_lock = mutex_alloc();
	aThread = cthread_fork(ProcA, (any_t) &proc_depth);
	cthread_detach(aThread);
	thread = cthread_thread(aThread);

	while( 1 )
	{
		/* Wait for thread to finish task A */
		mutex_lock(task_done_lock);
		while( proc != procADone )
			condition_wait(task_done, task_done_lock);
		mutex_unlock(task_done_lock);

		/* Send the thread to ProcB() */
		sleep(1);
		thread_suspend(thread);
		/* Push current pc on stack */
		threadState.areg[7] -= sizeof(long);
		*((int **) threadState.areg[7]) = &proc_depth;
		threadState.areg[7] -= sizeof(long);
		*((int *) threadState.areg[7]) = PC_FIELD(threadState);
fprintf(stderr, "M:: sp = 0x%x\n", threadState.areg[7]);
		PC_FIELD(threadState) = ProcB;
		mach_call(thread_set_state(thread, REGS_STATE,
				   (thread_state_t)&threadState, threadStateCount),
			"thread_set_state", "set ProcB()");
		thread_resume(thread);

		/* Wait for thread to finish task B */
		mutex_lock(task_done_lock);
		while( proc != procADone )
			condition_wait(task_done, task_done_lock);
		mutex_unlock(task_done_lock);

		/* Send the thread to ProcA() */
		sleep(1);
		thread_suspend(thread);
		threadState.areg[7] -= sizeof(long);
		*((int **) threadState.areg[7]) = &proc_depth;
		threadState.areg[7] -= sizeof(long);
		*((int *) threadState.areg[7]) = PC_FIELD(threadState);
fprintf(stderr, "M:: sp = 0x%x\n", threadState.areg[7]);
		PC_FIELD(threadState) = ProcA;
		mach_call(thread_set_state(thread, REGS_STATE,
				   (thread_state_t)&threadState, threadStateCount),
			"thread_set_state", "set ProcA()");
		thread_resume(thread);
	}
}

void ProcA(int *proc_depth)
{
thread_t thread;
int current_depth;
unsigned long *ts = (unsigned long *)&threadState, *fp, *sp;

	asm("movel a6, a6@(-16)");
	asm("movel a7, a6@(-20)");
	*(ts + 14) = fp;
	*(ts + 15) = sp;
	/* Write the thread info */
	thread = thread_self();
	fprintf(stderr, "A:: 0x%x in ProcA()\n", thread);
	fprintf(stderr, "A:: sp@(0) 0x%x = 0x%x\n", sp, *sp);
	fprintf(stderr, "A:: sp@(4) 0x%x = 0x%x\n", sp + 1, *(sp + 1));
	fprintf(stderr, "A:: sp@(8) 0x%x = 0x%x\n", sp + 2, *(sp + 2));
	fprintf(stderr, "A:: fp@(0) 0x%x = 0x%x\n", fp, *fp);
	fprintf(stderr, "A:: fp@(4) 0x%x = 0x%x\n", fp + 1, *(fp + 1));
	fprintf(stderr, "A:: fp@(8) 0x%x = 0x%x\n", fp + 2, *(fp + 2));

	if( *proc_depth == 0 )
	{
		mutex_lock(task_ready_lock);
			proc = procAReady;
		mutex_unlock(task_ready_lock);
		condition_signal(task_ready);
		cthread_set_data(cthread_self(), 0);
	}
	current_depth = ++(*proc_depth);
	fprintf(stderr, "A:: depth = %d\n", current_depth);

	asm("lea pc@, a0");
	asm("movel a0, _threadState+68");
fprintf(stderr, "A:: pc = 0x%x\n", PC_FIELD(threadState));
fprintf(stderr, "A:: waiting...\n");
	mutex_lock(task_done_lock);
		proc = procADone;
	mutex_unlock(task_done_lock);
	condition_signal(task_done);

	while(1);
}

void ProcB(int *proc_depth)
{
thread_t thread;
unsigned long *ts = (unsigned long *)&threadState, *fp, *sp;

	asm("movel a6, a6@(-12)");
	asm("movel a7, a6@(-16)");
	*(ts + 14) = fp;
	*(ts + 15) = sp;
	thread = thread_self();

	/* Write the thread info */
	fprintf(stderr, "0x%x in ProcB()\n", thread);
	fprintf(stderr, "B:: 0x%x in ProcB()\n", thread);
	fprintf(stderr, "B:: sp@(0) 0x%x = 0x%x\n", sp, *sp);
	fprintf(stderr, "B:: sp@(4) 0x%x = 0x%x\n", sp + 1, *(sp + 1));
	fprintf(stderr, "B:: sp@(8) 0x%x = 0x%x\n", sp + 2, *(sp + 2));
	fprintf(stderr, "B:: fp@(0) 0x%x = 0x%x\n", fp, *fp);
	fprintf(stderr, "B:: fp@(4) 0x%x = 0x%x\n", fp + 1, *(fp + 1));
	fprintf(stderr, "B:: fp@(8) 0x%x = 0x%x\n", fp + 2, *(fp + 2));

	asm("lea pc@, a0");
	asm("movel a0, _threadState+68");
fprintf(stderr, "B:: pc = 0x%x\n", PC_FIELD(threadState));
fprintf(stderr, "B:: waiting...\n");
	mutex_lock(task_done_lock);
		proc = procBDone;
	mutex_unlock(task_done_lock);
	condition_signal(task_done);

	while(1);
}
